import { getPost as publicGetPost, getPostBySlug as publicGetPostBySlug, listPosts as publicListPosts, queryPosts as publicQueryPosts, getPostMetrics as publicGetPostMetrics, queryPostCountStats as publicQueryPostCountStats, getTotalPosts as publicGetTotalPosts } from './blog-v3-post-posts.public.js';
import { createEventModule } from '@wix/sdk-runtime/event-definition-modules';
import { BuildRESTFunction, MaybeContext } from '@wix/sdk-types';
import { onPostCreated as publicOnPostCreated } from './blog-v3-post-posts.public.js';
import { onPostDeleted as publicOnPostDeleted } from './blog-v3-post-posts.public.js';
import { onPostLiked as publicOnPostLiked } from './blog-v3-post-posts.public.js';
import { onPostUnliked as publicOnPostUnliked } from './blog-v3-post-posts.public.js';
import { onPostUpdated as publicOnPostUpdated } from './blog-v3-post-posts.public.js';
export declare const getPost: MaybeContext<BuildRESTFunction<typeof publicGetPost> & typeof publicGetPost>;
export declare const getPostBySlug: MaybeContext<BuildRESTFunction<typeof publicGetPostBySlug> & typeof publicGetPostBySlug>;
export declare const listPosts: MaybeContext<BuildRESTFunction<typeof publicListPosts> & typeof publicListPosts>;
export declare const queryPosts: MaybeContext<BuildRESTFunction<typeof publicQueryPosts> & typeof publicQueryPosts>;
export declare const getPostMetrics: MaybeContext<BuildRESTFunction<typeof publicGetPostMetrics> & typeof publicGetPostMetrics>;
export declare const queryPostCountStats: MaybeContext<BuildRESTFunction<typeof publicQueryPostCountStats> & typeof publicQueryPostCountStats>;
export declare const getTotalPosts: MaybeContext<BuildRESTFunction<typeof publicGetTotalPosts> & typeof publicGetTotalPosts>;
/**
 * Triggered when a post is created.
 */
export declare const onPostCreated: ReturnType<typeof createEventModule<typeof publicOnPostCreated>>;
/**
 * Triggered when a post is deleted.
 */
export declare const onPostDeleted: ReturnType<typeof createEventModule<typeof publicOnPostDeleted>>;
/**
 * Triggered when a post is liked.
 */
export declare const onPostLiked: ReturnType<typeof createEventModule<typeof publicOnPostLiked>>;
/**
 * Triggered when a post is unliked.
 */
export declare const onPostUnliked: ReturnType<typeof createEventModule<typeof publicOnPostUnliked>>;
/**
 * Triggered when a post is updated.
 */
export declare const onPostUpdated: ReturnType<typeof createEventModule<typeof publicOnPostUpdated>>;
export { NodeType, WidthType, PluginContainerDataAlignment, Type, Target, TextAlignment, LineStyle, Width, Alignment, ViewMode, LayoutType, Orientation, Crop, ThumbnailsAlignment, Source, MapType, ViewRole, VoteRole, PollLayoutType, PollLayoutDirection, BackgroundType, DecorationType, FontType, AppType, InitialExpandedItems, Direction, VerticalAlignment, NullValue, ModerationStatusStatus, WebhookIdentityType, GetPostsSort, PostFieldField, GetPostTemplatesSort, Origin, Status, Field, SortOrder, QueryPublicationsCountStatsRequestOrder, Order, } from './blog-v3-post-posts.universal.js';
export { Post, CoverMedia, CoverMediaMediaOneOf, FocalPoint, PostCountInfo, Metrics, SeoSchema, Keyword, Tag, Settings, RichContent, Node, NodeDataOneOf, NodeStyle, ButtonData, Border, Colors, PluginContainerData, PluginContainerDataWidth, PluginContainerDataWidthDataOneOf, Spoiler, Height, Styles, Link, LinkDataOneOf, Rel, CodeBlockData, TextStyle, DividerData, FileData, FileSource, FileSourceDataOneOf, PDFSettings, GalleryData, V1Media, Image, Video, Item, ItemDataOneOf, GalleryOptions, Layout, ItemStyle, Thumbnails, GIFData, GIF, HeadingData, HTMLData, HTMLDataDataOneOf, ImageData, LinkPreviewData, MapData, MapSettings, ParagraphData, PollData, Permissions, Option, PollSettings, PollLayout, OptionLayout, Gradient, Background, BackgroundBackgroundOneOf, PollDesign, OptionDesign, Poll, PollDataLayout, Design, TextData, Decoration, DecorationDataOneOf, AnchorData, ColorData, LinkData, MentionData, FontSizeData, SpoilerData, AppEmbedData, AppEmbedDataAppDataOneOf, BookingData, EventData, VideoData, PlaybackOptions, EmbedData, Oembed, CollapsibleListData, TableData, Dimensions, TableCellData, CellStyle, BorderColors, ListValue, AudioData, OrderedListData, BulletedListData, BlockquoteData, CaptionData, LayoutCellData, Metadata, DocumentStyle, TextNodeStyle, ModerationDetails, Media, MediaMediaOneOf, WixMedia, VideoResolution, EmbedMedia, EmbedThumbnail, EmbedVideo, PostTranslation, OldBlogMigratedEvent, PostCategoriesUpdated, PostTagsUpdated, ScheduledPostPublished, DomainEvent, DomainEventBodyOneOf, EntityCreatedEvent, RestoreInfo, EntityUpdatedEvent, EntityDeletedEvent, ActionEvent, MessageEnvelope, IdentificationData, IdentificationDataIdOneOf, ConvertDraftJsToRichContentRequest, ConvertDraftJsToRichContentResponse, ConvertRichContentToDraftJsRequest, ConvertRichContentToDraftJsResponse, ListDemoPostsRequest, BlogPaging, ListDemoPostsResponse, MetaData, ListTemplatesRequest, ListTemplatesResponse, Category, CategoryTranslation, GetTemplateRequest, GetTemplateResponse, CreateDraftPostFromTemplateRequest, CreateDraftPostFromTemplateResponse, DraftPost, DraftPostTranslation, GetTotalLikesPerMemberRequest, GetTotalLikesPerMemberResponse, PostLiked, PostLikedInitiatorOneOf, PostUnliked, PostUnlikedInitiatorOneOf, PostCountersUpdated, PostCountersUpdatedInitiatorOneOf, PostOwnerChanged, InitialPostsCopied, GetPostRequest, GetPostResponse, GetPostBySlugRequest, GetPostBySlugResponse, ListPostsRequest, ListPostsResponse, QueryPostsRequest, Sorting, PlatformQuery, PlatformQueryPagingMethodOneOf, Paging, CursorPaging, QueryPostsResponse, PagingMetadataV2, Cursors, GetPostMetricsRequest, GetPostMetricsResponse, BulkGetPostMetricsRequest, BulkGetPostMetricsResponse, ViewPostRequest, ViewPostResponse, LikePostRequest, LikePostResponse, UnlikePostRequest, UnlikePostResponse, PinPostRequest, PinPostResponse, UnpinPostRequest, UnpinPostResponse, ListPostsArchiveRequest, ListPostsArchiveResponse, BulkGetPostReactionsRequest, BulkGetPostReactionsResponse, Reactions, QueryPublicationsCountStatsRequest, QueryPublicationsCountStatsResponse, PeriodPublicationsCount, QueryPostCountStatsRequest, QueryPostCountStatsResponse, PeriodPostCount, GetTotalPublicationsRequest, GetTotalPublicationsResponse, GetTotalPostsRequest, GetTotalPostsResponse, GetPostResponseNonNullableFields, GetPostBySlugResponseNonNullableFields, ListPostsResponseNonNullableFields, QueryPostsResponseNonNullableFields, GetPostMetricsResponseNonNullableFields, QueryPostCountStatsResponseNonNullableFields, GetTotalPostsResponseNonNullableFields, BaseEventMetadata, EventMetadata, PostCreatedEnvelope, PostDeletedEnvelope, PostLikedEnvelope, PostUnlikedEnvelope, PostUpdatedEnvelope, GetPostOptions, GetPostBySlugOptions, ListPostsOptions, QueryPostsOptions, PostsQueryResult, PostsQueryBuilder, QueryPostCountStatsOptions, GetTotalPostsOptions, } from './blog-v3-post-posts.universal.js';
